// Result Object
function nsAutoCompleteResultSS(searchstring, searchresult){
  this._searchString = searchstring;
  this._searchResult = searchresult;
}
nsAutoCompleteResultSS.prototype = {
  _searchResults : {
    values : [],
    comments : []
  },

  _defaultIndex : 0,
  _errorDescription : "",
  _searchResult : Components.interfaces.nsIAutoCompleteResult.RESULT_SUCCESS,
  _searchString : "",

  get defaultIndex() { return this._defaultIndex; },
  get errorDescription() { return this._errorDescription; },
  get matchCount(){ return this._searchResults.values.length; },
  get searchResult(){ return this._searchResult; },
  get searchString(){ return this._searchString; },

  getCommentAt : function(index){
    return this._searchResults.comments[index];
  },
  getStyleAt : function(index){ return null; },
  getValueAt : function(index){ return this._searchResults.values[index]; },
  removeValueAt : function(index, removeFromDb){
    this._searchResults.values.splice(index, 1);
    this._searchResults.comments.splice(index, 1);
  },
  QueryInterface: function(aIID){
    if( aIID.equals( Components.interfaces.nsIAutoCompleteResult ) ||
     aIID.equals( Components.interfaces.nsISupports ) )
      return this;
    else throw Components.results.NS_NOINTERFACE;
  }
};

// Suggest Main Container
function nsAutoCompleteControllerSSSuggest(arg){
//dump("nsAutoCompleteControllerSSSuggest initilized : " + arg + "\n");

  this._engineType = arg;

  switch(arg){
    case "google-en" : this._engineURL = "http://www.google.com/complete/search?csv=t&qu="; break;
    case "google-ja" : this._engineURL = "http://www.google.com/complete/search?csv=t&hl=ja&qu="; break;
    case "goo-spelling" : this._engineURL = "http://dictionary.goo.ne.jp/xml/lookupfw.php?MT="; break;
  }
//dump("nsAutoCompleteControllerSSSuggest initilized : " + this._engineURL + "\n");
}
nsAutoCompleteControllerSSSuggest.prototype = {
  _engineType : "google-en",
  _engineURL : "http://www.google.com/complete/search?csv=t&qu=",
  _xmlhttprequest : null,
  _listener : null,
  _onReadyStateChange : function(){},
  _encodeURI2 : function(aString,aCharset){
    return Components.classes["@mozilla.org/intl/texttosuburi;1"]
     .getService(Components.interfaces.nsITextToSubURI)
     .ConvertAndEscape(aCharset,aString)
     .replace(/( |%2520)/g, "%20").replace(/%2B/g, "+");
  },

  //nsIAutoCompleteSearch
  startSearch : function(searchString, searchParam, previousResult, listener){
//dump("nsAutoCompleteControllerSSSuggest startSearch : " + searchString + "\n");
    if(this._xmlhttprequest) this._xmlhttprequest.abort(); // stop(interrupt) search

    this._listener = listener;
    this.__searchString = searchString;
    if(searchString.length <= 0 || ((this._engineType=="goo_spelling") && (searchString.length<=1)) ){
      this._listener.onSearchResult(this, new nsAutoCompleteResultSS(searchString, Components.interfaces.nsIAutoCompleteResult.RESULT_FAILURE) );
      return;
    }

    this._xmlhttprequest = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
      .createInstance(Components.interfaces.nsIXMLHttpRequest);

    var me = this;
    this._xmlhttprequest.onreadystatechange = function(){
      if(me._xmlhttprequest && me._xmlhttprequest.readyState == 4){
//dump("nsAutoCompleteControllerSSSuggest startSearch : onreadystatechange \n");
        var status;
        try{
          status = me._xmlhttprequest.status;
        }catch(ex){ return; }
        if(status == 200){
          var res = me._xmlhttprequest.responseText;
          if(!res) return;
//dump("nsAutoCompleteControllerSSSuggest startSearch : onreadystatechange : res=" + res + " \n");

          if(/^google-(ja|en)$/.test(me._engineType)){
//dump("nsAutoCompleteControllerSSSuggest startSearch : onreadystatechange : is google! \n");
            var lines = res.split("\n");
            var result = new nsAutoCompleteResultSS(lines[0].substring(1,lines[0].length-1), (lines.length >= 3)? Components.interfaces.nsIAutoCompleteResult.RESULT_SUCCESS : Components.interfaces.nsIAutoCompleteResult.RESULT_NOMATCH);

            if(lines.length >= 3){
              var values = lines[1].substring(1, lines[1].length - 2).split("\",\"");
              var comments = lines[2].substring(1, lines[2].length - 2).split("\",\"");
              for(var i = 0; i < values.length; i++){
                values[i] = unescape(values[i]);
                comments[i] = unescape(comments[i]);
              }
              result._searchResults.values = values;
              result._searchResults.comments = comments;
            }
            me._listener.onSearchResult(me, result);
          }else if(me._engineType == "goo-spelling"){
            res = me._xmlhttprequest.responseXML;
//dump("nsAutoCompleteControllerSSSuggest startSearch : onreadystatechange : res=" + res + " \n");
            var lCands = res.getElementsByTagName("cand");
            var result = new nsAutoCompleteResultSS(me.__searchString, (lCands.length > 0)? Components.interfaces.nsIAutoCompleteResult.RESULT_SUCCESS : Components.interfaces.nsIAutoCompleteResult.RESULT_NOMATCH);

            if(lCands.length > 0){
              var values = new Array(lCands.length);
              var comments = new Array(lCands.length);
              for(var i = 0; i < values.length; i++){
                values[i] = unescape(lCands.item(i).textContent);
                comments[i] = "";
              }
              result._searchResults.values = values;
              result._searchResults.comments = comments;
            }
            me._listener.onSearchResult(me, result);
          }

          me._xmlhttprequest = null;
          me._listener = null;
        }
      }
    };
    this._xmlhttprequest.onerror = function(){
      if(me._listener)
        me._listener.onSearchResult(me, new nsAutoCompleteResultSS(me.__searchString, Components.interfaces.nsIAutoCompleteResult.RESULT_FAILURE) );
    };
//dump("nsAutoCompleteControllerSSSuggest startSearch : send : " + this._engineURL + me._encodeURI2(searchString,"UTF-8") + "\n");

    this._xmlhttprequest.open("GET", this._engineURL + me._encodeURI2(searchString,"UTF-8"), true);
    this._xmlhttprequest.send(null);
  }, // startSearch
  stopSearch : function(){
    if(this._xmlhttprequest){
      this._xmlhttprequest.abort();
      this._xmlhttprequest = null;
      this._listener = null;
    }
  },

  QueryInterface : function(aIID){
    if(aIID.equals(Components.interfaces.nsIAutoCompleteSearch) ||
     aIID.equals(Components.interfaces.nsISupports))
      return this;
    else throw Components.results.NS_NOINTERFACE;
  }
};

var gModule = {
  _firstTime : true,

  registerSelf : function(aComponentManager, aFileSpec, aLocation, aType){
    if(this._firstTime){
      this._firstTime = false;
      throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
    }
    aComponentManager = aComponentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);

    for(var key in this._objects){
      aComponentManager.registerFactoryLocation(
       this._objects[key].CLASSID, this._objects[key].NAME, this._objects[key].CCID,
       aFileSpec, aLocation, aType);
    }
  },
  getClassObject : function(aComponentManager, aCID, aIID){
    if(!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    for(var key in this._objects){
      if(aCID.equals(this._objects[key].CLASSID)){
        return this._objects[key].factory;
      }
    }

    throw Components.results.NS_NOINTERFACE;
  },

  // Class data lib.
  _objects : {
    google_en : {
      CLASSID : Components.ID("{37a9d1bb-7b5b-46ae-b899-38d162f7abf3}"),
      NAME : "nsAutoCompleteResultSS : Google Suggest (en)",
      CCID : "@mozilla.org/autocomplete/search;1?name=ss-suggest-google-en",
      factory : {
        createInstance : function(aOuter, aIID){
          if(aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
          return (new nsAutoCompleteControllerSSSuggest("google-en")).QueryInterface(aIID);
        }
      }
    },
    google_ja : {
      CLASSID : Components.ID("{3471394d-15eb-43b7-87b7-f9b8136cef06}"),
      NAME : "nsAutoCompleteResultSS : Google Suggest (ja)",
      CCID : "@mozilla.org/autocomplete/search;1?name=ss-suggest-google-ja",
      factory : {
        createInstance : function(aOuter, aIID){
          if(aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
          return (new nsAutoCompleteControllerSSSuggest("google-ja")).QueryInterface(aIID);
        }
      }
    },
    goo_spelling : {
      CLASSID : Components.ID("{195957cf-05f6-4555-aee4-64f3a20c207a}"),
      NAME : "nsAutoCompleteResultSS : Goo Spelling Assist (en)",
      CCID : "@mozilla.org/autocomplete/search;1?name=ss-suggest-goo-spelling",
      factory : {
        createInstance : function(aOuter, aIID){
          if(aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
          return (new nsAutoCompleteControllerSSSuggest("goo-spelling")).QueryInterface(aIID);
        }
      }
    }
  },
  canUnload : function (aComponentManager){ return true }
};

function NSGetModule(aComponentManager, fileSpec){
  return gModule;
}
